## colobot 0.1.12

=== CMakeLists.txt ===
##
# Main CMake project file
# Contains global options and definitions
##

cmake_minimum_required(VERSION 2.8)

project(colobot C CXX)

##
# Project version
##
set(COLOBOT_VERSION_CODENAME "Gold")
set(COLOBOT_VERSION_MAJOR    0)
set(COLOBOT_VERSION_MINOR    1)
set(COLOBOT_VERSION_REVISION 12)

# Used on official releases
set(COLOBOT_VERSION_RELEASE_CODENAME "-alpha")
# Used on unreleased, development builds
#set(COLOBOT_VERSION_UNRELEASED "+alpha")

# Append git characteristics to version
if(DEFINED COLOBOT_VERSION_UNRELEASED)
    if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
        find_package(Git)
        execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse --abbrev-ref HEAD
                        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                        OUTPUT_VARIABLE GIT_BRANCH
                        OUTPUT_STRIP_TRAILING_WHITESPACE)
        execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
                        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                        OUTPUT_VARIABLE GIT_REVISION
                        OUTPUT_STRIP_TRAILING_WHITESPACE)
        set(COLOBOT_VERSION_UNRELEASED "${COLOBOT_VERSION_UNRELEASED}-git-${GIT_BRANCH}~r${GIT_REVISION}")
        set(COLOBOT_VERSION_DISPLAY "git-${GIT_BRANCH}~r${GIT_REVISION}")
    else()
        set(COLOBOT_VERSION_DISPLAY "${COLOBOT_VERSION_CODENAME}-${COLOBOT_VERSION_UNRELEASED}")
    endif()
else()
    set(COLOBOT_VERSION_DISPLAY "${COLOBOT_VERSION_MAJOR}.${COLOBOT_VERSION_MINOR}.${COLOBOT_VERSION_REVISION}${COLOBOT_VERSION_RELEASE_CODENAME}")
endif()

set(COLOBOT_VERSION_FULL "${COLOBOT_VERSION_MAJOR}.${COLOBOT_VERSION_MINOR}.${COLOBOT_VERSION_REVISION}${COLOBOT_VERSION_UNRELEASED}${COLOBOT_VERSION_RELEASE_CODENAME}")
message(STATUS "Building Colobot \"${COLOBOT_VERSION_CODENAME}\" (${COLOBOT_VERSION_FULL})")

set(BUILD_NUMBER 0)
if(NOT "$ENV{BUILD_NUMBER}" STREQUAL "")
    set(BUILD_NUMBER "$ENV{BUILD_NUMBER}")
    message(STATUS "CI build #${BUILD_NUMBER}")
endif()


##
# Platform detection and some related checks
##
if("${CMAKE_SYSTEM_NAME}" MATCHES "Windows")
    message(STATUS "Build for Windows system")
    set(PLATFORM_WINDOWS 1)
    set(PLATFORM_GNU     0)
    set(PLATFORM_LINUX   0)
    set(PLATFORM_MACOSX  0)
    set(PLATFORM_OTHER   0)

    # Platform-dependent implementation of system.h
    set(SYSTEM_CPP_MODULE "system_windows.cpp")
    set(SYSTEM_H_MODULE "system_windows.h")
elseif("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
    message(STATUS "Build for Linux system")
    set(PLATFORM_WINDOWS 0)
    set(PLATFORM_LINUX   1)
    set(PLATFORM_GNU     1)
    set(PLATFORM_MACOSX  0)
    set(PLATFORM_OTHER   0)

    # Platform-dependent implementation of system.h
    set(SYSTEM_CPP_MODULE "system_linux.cpp")
    set(SYSTEM_H_MODULE "system_linux.h")
elseif("${CMAKE_SYSTEM_NAME}" MATCHES "kFreeBSD" OR "${CMAKE_SYSTEM_NAME}" STREQUAL "GNU")
    message(STATUS "Build for kFreeBSD system")
    set(PLATFORM_WINDOWS 0)
    set(PLATFORM_LINUX   0)
    set(PLATFORM_GNU     1)
    set(PLATFORM_MACOSX  0)
    set(PLATFORM_OTHER   0)

    # Platform-dependent implementation of system.h
    set(SYSTEM_CPP_MODULE "system_other.cpp")
    set(SYSTEM_H_MODULE "system_other.h")
elseif("${CMAKE_SYSTEM_NAME}" MATCHES "Darwin")
    message(STATUS "Build for Mac OSX system")
    set(PLATFORM_WINDOWS 0)
    set(PLATFORM_LINUX   0)
    set(PLATFORM_GNU     0)
    set(PLATFORM_MACOSX  1)
    set(PLATFORM_OTHER   0)

    # Platform-dependent implementation of system.h
    set(SYSTEM_CPP_MODULE "system_macosx.cpp")
    set(SYSTEM_H_MODULE "system_macosx.h")
    # To avoid CMake warning
    set(CMAKE_MACOSX_RPATH 1)
else()
    message(STATUS "Build for other system")
    set(PLATFORM_WINDOWS 0)
    set(PLATFORM_LINUX   0)
    set(PLATFORM_GNU     0)
    set(PLATFORM_MACOSX  0)
    set(PLATFORM_OTHER   1)

    # Platform-dependent implementation of system.h
    set(SYSTEM_CPP_MODULE "system_other.cpp")
    set(SYSTEM_H_MODULE "system_other.h")
endif()


##
# Build options
##

# Build targets should be placed in the root build directory
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

# Include cmake directory with some additional scripts
set(CMAKE_MODULE_PATH "${colobot_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

# MSVC needs different flags if linking statically
option(MSVC_STATIC "Link statically when using MSVC" OFF)

# Compiler detection
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.7)
        message(FATAL_ERROR "${PROJECT_NAME} requires GCC 4.7 or greater.")
    endif()

    message(STATUS "Detected GCC version 4.7+")

    set(NORMAL_CXX_FLAGS "-std=gnu++11 -Wall -Werror -Wold-style-cast -pedantic-errors -Wmissing-declarations")
    set(NORMAL_CXX_FLAGS "${NORMAL_CXX_FLAGS} -Wno-error=deprecated-declarations") # updated version of physfs is not available on some platforms so we keep using deprecated functions, see #958

    if(NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.0)
        set(NORMAL_CXX_FLAGS "${NORMAL_CXX_FLAGS} -Wsuggest-override")
    endif()

    set(RELEASE_CXX_FLAGS "-O2")
    set(DEBUG_CXX_FLAGS "-g -O0")
    set(TEST_CXX_FLAGS "-pthread")
    add_definitions(-DNOEXCEPT=noexcept -DHAVE_DEMANGLE)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.1)
        message(FATAL_ERROR "${PROJECT_NAME} requires Clang 3.1 or greater.")
    endif()

    message(STATUS "Detected Clang version 3.1+")

    set(NORMAL_CXX_FLAGS "-std=c++11 -Wall -Werror -Wold-style-cast -pedantic-errors -Wmissing-prototypes")
    set(NORMAL_CXX_FLAGS "${NORMAL_CXX_FLAGS} -Wno-error=deprecated-declarations") # updated version of physfs is not available on some platforms so we keep using deprecated functions, see #958
    set(RELEASE_CXX_FLAGS "-O2")
    set(DEBUG_CXX_FLAGS "-g -O0")
    set(TEST_CXX_FLAGS "-pthread")
    add_definitions(-DNOEXCEPT=noexcept -DHAVE_DEMANGLE)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    message(STATUS "Detected MSVC compiler")

    set(NORMAL_CXX_FLAGS "/wd\"4244\" /wd\"4309\" /wd\"4800\" /wd\"4996\" /wd\"4351\" /EHsc") # disable some useless warnings
    if(MSVC_STATIC)
        set(RELEASE_CXX_FLAGS "/MT /Ox")
        set(DEBUG_CXX_FLAGS "/MTd /ZI")
    else(MSVC_STATIC)
        set(RELEASE_CXX_FLAGS "/MD /Ox")
        set(DEBUG_CXX_FLAGS "/MDd /ZI")
    endif()
    set(TEST_CXX_FLAGS "")
    add_definitions(-DNOEXCEPT= -DHAS_MSVC_EXCEPTION_BUG)

    # Needed for Debug information (it's set to "No" by default for some reason)
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS} /DEBUG")
    set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS} /DEBUG")
else()
    message(FATAL_ERROR "Your C++ compiler doesn't seem to be supported.")
endif()


# Global compile flags
# These are specific to GCC/MinGW/clang; for other compilers, change as necessary
# The flags are used throughout src/ and test/ subdirs

# Special flags for boost
add_definitions(-DBOOST_NO_SCOPED_ENUMS -DBOOST_NO_CXX11_SCOPED_ENUMS)

set(COLOBOT_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${NORMAL_CXX_FLAGS}")
set(COLOBOT_CXX_FLAGS_RELEASE "${RELEASE_CXX_FLAGS}")
set(COLOBOT_CXX_FLAGS_DEBUG "${DEBUG_CXX_FLAGS}")

# Flags for gtest
set(COLOBOT_GTEST_CXX_FLAGS "${TEST_CXX_FLAGS}")


# Asserts can be enabled/disabled regardless of build type
option(ASSERTS "Enable assert()s" ON)

# Development build can be enabled/disabled regardless of build type
option(DEV_BUILD "Enable development build (enables some debugging tools, local setting paths, etc.)" OFF)

# Official build - changes text on the crash screen
# PLEASE DO NOT USE ON UNOFFICIAL BUILDS. Thanks.
option(OFFICIAL_COLOBOT_BUILD "Official build (changes crash screen text)" OFF)

# Portable build - load all data from current directory
option(PORTABLE "Portable build" OFF)

# Portable saves - suitable for e.g. putting the whole game on external storage and moving your saves with it
option(PORTABLE_SAVES "Portable saves" OFF)

# Building tests can be enabled/disabled
option(TESTS "Build tests" OFF)

# Building tool programs can be enabled/disabled
option(TOOLS "Build tool programs" OFF)

# CBot can also be a static library
option(CBOT_STATIC "Build CBot as static libary" OFF)

# Generate desktop files, manpage, etc.
option(DESKTOP "Generate desktop files, manpages, etc" ON)

# Doxygen docs are optional for installation
option(INSTALL_DOCS "Install Doxygen-generated documentation" OFF)

# Build OpenAL sound support
option(OPENAL_SOUND "Build OpenAL sound support" ON)

# This is useful in case you want to use static boost libraries
option(BOOST_STATIC "Link with static boost libraries" OFF)

# This is useful on Windows, if linking against standard GLEW dll fails
option(GLEW_STATIC "Link statically with GLEW" OFF)

# Sometimes helpful if there is a different version of gtest installed on system vs bundled
option(FORCE_BUNDLED_GTEST "Force the use of bundled gtest" OFF)

# This is for use with colobot-lint tool
option(COLOBOT_LINT_BUILD "Generate some additional CMake targets for use with colobot-lint" OFF)


# Default build type if not given is debug
if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "Build type not specified - assuming debug")
    set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# Warn about development build
if(DEV_BUILD)
    message(STATUS "Building with development extensions")
endif()


##
# Searching for packages
##

find_package(OpenGL 1.4 REQUIRED)
find_package(SDL2 REQUIRED)
find_package(SDL2_image REQUIRED)
find_package(SDL2_ttf REQUIRED)
find_package(PNG 1.2 REQUIRED)
find_package(Gettext REQUIRED)
find_package(PhysFS REQUIRED)

set(Boost_USE_STATIC_LIBS ${BOOST_STATIC})
set(Boost_USE_MULTITHREADED ON)
set(Boost_USE_STATIC_RUNTIME OFF)

set(Boost_ADDITIONALVERSION "1.51" "1.51.0")
find_package(Boost COMPONENTS system filesystem regex REQUIRED)

find_package(GLEW REQUIRED)

if (OPENAL_SOUND)
    find_package(OpenAL REQUIRED)
    include_directories(${OPENAL_INCLUDE_DIR})
    find_package(LibSndFile REQUIRED)
endif()


if(NOT ASSERTS)
    add_definitions(-DNDEBUG)
endif()

if(TESTS)
    add_definitions(-DTESTS -DTEST_VIRTUAL=virtual)
else()
    add_definitions(-DTEST_VIRTUAL=)
endif()

if(DEV_BUILD)
    add_definitions(-DDEV_BUILD)
endif()

##
# Additional settings to use when cross-compiling with MXE (http://mxe.cc/)
##

include("${colobot_SOURCE_DIR}/cmake/mxe.cmake")

##
# Additional settings for MSYS
##
include("${colobot_SOURCE_DIR}/cmake/msys.cmake")

##
# Additional functions for colobot-lint
##
include("${colobot_SOURCE_DIR}/cmake/colobot-lint.cmake")


##
# MSVC specific settings
##
set(WINGETOPT 0)
if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    message(STATUS "Adding MSVC-specific options")

    set(CBOT_STATIC 1) # only this works for some reason
    set(WINGETOPT 1) # use wingetopt library

    # Hide console in release builds
    if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
        set(CMAKE_WIN32_EXECUTABLE 1)
    endif()
endif()

##
# Localename
##
set(LOCALENAME_INCLUDE_DIR ${colobot_SOURCE_DIR}/lib/localename)
add_subdirectory(lib/localename)


##
# Wingetopt
##
if(WINGETOPT)
    set(WINGETOPT_INCLUDE_DIR ${colobot_SOURCE_DIR}/lib/wingetopt/src)
    add_subdirectory(lib/wingetopt)
endif()


##
# Doxygen docs
##

find_package(Doxygen)

if(DOXYGEN_FOUND AND DOXYGEN_DOT_FOUND)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
    add_custom_target(doc
                      ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
                      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                      COMMENT "Generating API documentation with Doxygen" VERBATIM)
endif()


##
# Targets
##

# Installation paths defined before compiling sources
if(PORTABLE OR (PLATFORM_WINDOWS AND MXE))
    # We need to use STRING because PATH doesn't accept relative paths

=== desktop/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

set(COLOBOT_ICON_FILE ${CMAKE_CURRENT_SOURCE_DIR}/colobot.svg)

# Render SVG icon in various sizes
find_program(RSVG_CONVERT rsvg-convert)
if(NOT RSVG_CONVERT)
    message(WARNING "rsvg-convert not found; desktop icons will not be generated")
endif()

find_program(XMLSTARLET xmlstarlet)
if(NOT XMLSTARLET)
    message(WARNING "xmlstarlet not found; desktop icons will not be generated")
endif()

if(RSVG_CONVERT AND XMLSTARLET AND (PLATFORM_GNU OR PLATFORM_MACOSX))
    add_custom_target(png-icons ALL DEPENDS ${COLOBOT_ICON_FILE})

    foreach(PNG_SIZE 512 256 128 48 32 16)
        # Using xmlstarlet to edit SVG file is a workaround for rsvg-convert bug (see: https://bugzilla.gnome.org/show_bug.cgi?id=762115)
        add_custom_command(
            OUTPUT ${PNG_SIZE}/colobot.png
            COMMAND mkdir -p ${PNG_SIZE}
            COMMAND ${XMLSTARLET} ed -u /*/@width -v ${PNG_SIZE} -u /*/@height -v ${PNG_SIZE} ${COLOBOT_ICON_FILE} > ${PNG_SIZE}/colobot.svg
            COMMAND ${RSVG_CONVERT} ${PNG_SIZE}/colobot.svg -o ${PNG_SIZE}/colobot.png
            )
        add_custom_target(png-icon-${PNG_SIZE} ALL DEPENDS ${PNG_SIZE}/colobot.png)
        add_dependencies(png-icons png-icon-${PNG_SIZE})

        if(PLATFORM_GNU)
            install(
                FILES ${CMAKE_CURRENT_BINARY_DIR}/${PNG_SIZE}/colobot.png
                DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/${PNG_SIZE}x${PNG_SIZE}/apps/
                )
        endif()
        # Prepare the ICNS icon generation
        list(APPEND ICNS_SRCS "${PNG_SIZE}/colobot.png")
    endforeach()

    # Pack icon for Mac OS
    if(PLATFORM_MACOSX)
        find_program(PNG2ICNS png2icns)
        if(NOT PNG2ICNS)
            message(WARNING "png2icns not found; icns file will not be generated")
        endif()

        if(PNG2ICNS)
            add_custom_command(OUTPUT Colobot.icns
                COMMAND ${PNG2ICNS} Colobot.icns ${ICNS_SRCS}
                DEPENDS png-icons
                )
            add_custom_target(icns-icon ALL DEPENDS Colobot.icns)
        endif()
    endif()

endif()

if(PLATFORM_GNU)
    # Install Desktop Entry file
    set(COLOBOT_DESKTOP_FILE colobot.desktop)
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${COLOBOT_DESKTOP_FILE}
        COMMAND ./create_desktop_file.sh > ${CMAKE_CURRENT_BINARY_DIR}/${COLOBOT_DESKTOP_FILE}
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
        COMMENT "Build ${COLOBOT_DESKTOP_FILE}"
        )
    add_custom_target(desktopfile ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${COLOBOT_DESKTOP_FILE})
    install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/${COLOBOT_DESKTOP_FILE}
            DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications/
        )

    # Install appdata
    install(
        FILES info.colobot.Colobot.appdata.xml
            DESTINATION ${CMAKE_INSTALL_PREFIX}/share/metainfo/
        )

    # Install Icon
    install(
        FILES ${COLOBOT_ICON_FILE}
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps/
        )

    # Translate translatable material
    find_program(PO4A po4a)
    if(NOT PO4A)
        message(WARNING "po4a not found; desktop and manpage files will not be translated")
    endif()

    if(PO4A)
        add_custom_target(desktop_po4a
            COMMAND ${PO4A} po4a.cfg
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
        add_dependencies(desktopfile desktop_po4a)
    endif()

    # Create manpage from pod-formatted file
    find_program(POD2MAN pod2man)
    if(NOT POD2MAN)
        message(WARNING "pod2man not found; manpage will not be generated")
    endif()

    if(POD2MAN)
        set(COLOBOT_MANPAGE_SECTION 6)

        macro(podman)
            cmake_parse_arguments(PM "" "PODFILE;LOCALE;" "" ${ARGN})
            if(PM_LOCALE)
                # This copes with the fact that english has no "/LANG" in the paths and filenames.
                set(SLASHLOCALE /${PM_LOCALE})
            endif()
            file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}${SLASHLOCALE})
            add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}${SLASHLOCALE}/colobot.${COLOBOT_MANPAGE_SECTION}
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${PM_PODFILE}
                       COMMAND ${POD2MAN} ARGS --section=${COLOBOT_MANPAGE_SECTION}
                                          --center="Colobot" --stderr --utf8
                                          --release="${COLOBOT_VERSION_FULL}"
                                          ${CMAKE_CURRENT_SOURCE_DIR}/${PM_PODFILE}
                                          ${CMAKE_CURRENT_BINARY_DIR}${SLASHLOCALE}/colobot.${COLOBOT_MANPAGE_SECTION}
               COMMENT "Create ${SLASHLOCALE}/colobot.${COLOBOT_MANPAGE_SECTION} manpage"
                      )
            add_custom_target(man${PM_LOCALE} ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}${SLASHLOCALE}/colobot.${COLOBOT_MANPAGE_SECTION})

            install(
                FILES ${CMAKE_CURRENT_BINARY_DIR}${SLASHLOCALE}/colobot.${COLOBOT_MANPAGE_SECTION}
                    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man${SLASHLOCALE}/man${COLOBOT_MANPAGE_SECTION}/ )

            add_dependencies(man man${PM_LOCALE})
        endmacro()

        # Create the english manpage
        podman(PODFILE colobot.pod)

        if(PO4A)
            # Translate the manpage to other languages
            add_dependencies(man desktop_po4a)
            file(GLOB LINGUAS_PO RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/po/ ${CMAKE_CURRENT_SOURCE_DIR}/po/*.po)
            string(REGEX REPLACE ".po$" "" LINGUAS ${LINGUAS_PO})
            foreach(LOCALE ${LINGUAS})
                podman(PODFILE lang/${LOCALE}/colobot.pod LOCALE ${LOCALE})
                add_dependencies(man${PM_LOCALE} desktop_po4a)
            endforeach()
        endif()
    endif()
endif(PLATFORM_GNU)

if(PLATFORM_MACOSX)
    configure_file(Info.plist.cmake ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
endif(PLATFORM_MACOSX)

if(PLATFORM_WINDOWS)
    if(COLOBOT_VERSION_REVISION MATCHES "([0-9]+)\\.([0-9]+)")
        string(REGEX REPLACE "([0-9]+)\\.([0-9]+)" "\\1,\\2" COLOBOT_VERSION_REVISION_COMMA "${COLOBOT_VERSION_REVISION}")
        set(COLOBOT_VERSION_4COMMAS "${COLOBOT_VERSION_MAJOR},${COLOBOT_VERSION_MINOR},${COLOBOT_VERSION_REVISION_COMMA}")
    else()
        set(COLOBOT_VERSION_4COMMAS "${COLOBOT_VERSION_MAJOR},${COLOBOT_VERSION_MINOR},${COLOBOT_VERSION_REVISION},0")
    endif()
    configure_file(colobot.rc.cmake ${CMAKE_CURRENT_BINARY_DIR}/colobot.rc)
endif(PLATFORM_WINDOWS)


##
# Packaging
##
set(CPACK_BUNDLE_NAME "Colobot: Gold Edition")
set(CPACK_PACKAGE_FILE_NAME "colobot-${COLOBOT_VERSION_FULL}")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/../README.md")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Colobot: Gold Edition")
set(CPACK_PACKAGE_VENDOR "TerranovaTeam")

set(CPACK_PACKAGE_VERSION_MAJOR ${COLOBOT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${COLOBOT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${COLOBOT_VERSION_REVISION})

if(PLATFORM_WINDOWS)
    set(CPACK_STRIP_FILES TRUE)

    # Don't version the install directory, and allow overwriting
    set(CPACK_PACKAGE_INSTALL_DIRECTORY "Colobot")
    set(CPACK_NSIS_DEFINES "SetOverwrite on\nBrandingText \\\"Colobot: Gold Edition (${COLOBOT_VERSION_FULL})\\\"")
    # Install the executable directly in Program Files/Colobot/
    set(CPACK_NSIS_EXECUTABLES_DIRECTORY ".")
    set(CPACK_PACKAGE_EXECUTABLES "colobot" "Colobot: Gold Edition")

    # Branding
    ## Installation and uninstallation icons
    set(CPACK_NSIS_MUI_ICON    ${CMAKE_CURRENT_SOURCE_DIR}/colobot.ico)
    set(CPACK_NSIS_MUI_UNIICON ${CMAKE_CURRENT_SOURCE_DIR}/colobot.ico)
    ## Header and Left banner images
    set(CPACK_PACKAGE_ICON     "")
    set(CPACK_NSIS_INSTALLER_ICON_CODE    "!define MUI_HEADERIMAGE_BITMAP       \\\"${CMAKE_CURRENT_SOURCE_DIR}/colobot_nsis.bmp\\\"
                                           !define MUI_WELCOMEFINISHPAGE_BITMAP \\\"${CMAKE_CURRENT_SOURCE_DIR}/colobot_nsis_left.bmp\\\"")

    ## Allow to directly run Colobot at the end of the installation
    set(CPACK_NSIS_MUI_FINISHPAGE_RUN "colobot.exe")

    ## TODO: Find a way to have no license prompt. Until that, display the GPL-3
    set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/../LICENSE.txt)

elseif(PLATFORM_MACOSX)
    set(CPACK_BUNDLE_NAME "Colobot")
    set(CPACK_GENERATOR "Bundle")
    set(CPACK_BUNDLE_ICON  ${CMAKE_CURRENT_BINARY_DIR}/Colobot.icns)
    set(CPACK_PACKAGE_ICON ${CMAKE_CURRENT_BINARY_DIR}/Colobot.icns)
    set(CPACK_BUNDLE_PLIST ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)

    set(CPACK_BINARY_DRAGNDROP ON)

    install(CODE "
        include(BundleUtilities)
        message(STATUS \"fixup_bundle(\${CMAKE_INSTALL_PREFIX}/${COLOBOT_INSTALL_BIN_DIR}/colobot/\")
        fixup_bundle(\"\${CMAKE_INSTALL_PREFIX}/${COLOBOT_INSTALL_BIN_DIR}/colobot\"   \"\"   \"\")
        ")
endif()

include(CPack)

=== levels/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

include(../i18n-tools/I18NTools.cmake)

set(LEVEL_INSTALL_DATA_DIR ${COLOBOT_INSTALL_DATA_DIR}/levels)

##
# Add level category directory with all chapters inside
##
function(add_level_category level_category_dir)

    # If translations are turned off, just install all files as they are
    if(NOT TRANSLATIONS)
        install(DIRECTORY ${level_category_dir} DESTINATION ${LEVEL_INSTALL_DATA_DIR})
        return()
    endif()

    message(STATUS "Adding translation targets for level/${level_category_dir}")

    add_chaptertitles(${level_category_dir})

    file(GLOB level_dirs RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${level_category_dir}/chapter*/level*)
    foreach(level_dir ${level_dirs})
        add_level(${level_dir})
    endforeach()

    # Install all other category files
    install(DIRECTORY ${level_category_dir}/ DESTINATION ${LEVEL_INSTALL_DATA_DIR}/${level_category_dir}
            PATTERN "chapter*" EXCLUDE
            PATTERN "po" EXCLUDE)

    # Install all other chapter files
    file(GLOB chapter_dirs RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${level_category_dir}/chapter*)
    foreach(chapter_dir ${chapter_dirs})
        install(DIRECTORY ${chapter_dir}/ DESTINATION ${LEVEL_INSTALL_DATA_DIR}/${chapter_dir}
                PATTERN "level*" EXCLUDE
                PATTERN "chaptertitle.txt" EXCLUDE)
    endforeach()

endfunction()

##
# Add chaptertitles
##
function(add_chaptertitles level_category_dir)

    set(work_dir ${DATA_BINARY_DIR}/levels-po/${level_category_dir})
    generate_translations(translated_chaptertitle_files
                          "chaptertitles"
                          ${CMAKE_CURRENT_SOURCE_DIR}
                          ${level_category_dir}
                          ${level_category_dir}/po
                          ${work_dir}
                          "")

    install_preserving_relative_paths("${translated_chaptertitle_files}"
                                      ${work_dir}
                                      ${LEVEL_INSTALL_DATA_DIR}/${level_category_dir})

endfunction()

##
# Add level directory
##
function(add_level level_dir)

    set(work_dir ${DATA_BINARY_DIR}/levels-po/${level_dir})
    generate_translations(translated_level_files
                          "level"
                          ${CMAKE_CURRENT_SOURCE_DIR}
                          ${level_dir}
                          ${level_dir}/po
                          ${work_dir}
                          "")

    file(GLOB english_help_files ${level_dir}/help/*)
    install(FILES ${english_help_files} DESTINATION ${LEVEL_INSTALL_DATA_DIR}/${level_dir}/help)

    install_preserving_relative_paths("${translated_level_files}"
                                      ${work_dir}
                                      ${LEVEL_INSTALL_DATA_DIR}/${level_dir})

    # Install all other (non-translatable) files
    install(DIRECTORY ${level_dir}/ DESTINATION ${LEVEL_INSTALL_DATA_DIR}/${level_dir}
            PATTERN "help*" EXCLUDE
            PATTERN "po*" EXCLUDE
            PATTERN "scene.txt" EXCLUDE)

endfunction()


add_level_category(missions)
add_level_category(freemissions)
add_level_category(exercises)
add_level_category(challenges)
add_level_category(battles)

install(DIRECTORY other DESTINATION ${LEVEL_INSTALL_DATA_DIR})

=== po/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

find_package(Gettext REQUIRED)

set(_potFile colobot.pot)

# Extract translations

find_program(XGETTEXT_CMD xgettext)

add_custom_command(OUTPUT ${_potFile}
    COMMAND ${XGETTEXT_CMD} ${colobot_SOURCE_DIR}/src/app/app.cpp --output=${_potFile} --no-wrap
    COMMAND ${XGETTEXT_CMD} ${colobot_SOURCE_DIR}/src/common/restext.cpp --output=${_potFile} --no-wrap --join-existing --no-location --keyword=TR
    COMMAND ${XGETTEXT_CMD} ${colobot_SOURCE_DIR}/src/script/script.cpp --output=${_potFile} --no-wrap --join-existing --no-location
    COMMAND sed -i -e "s|^\\(\"POT-Creation-Date:\\).*$|\\1 DATE\\\\n\"|" ${_potFile}

    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Extract translatable messages to ${_potFile}"
    VERBATIM
)

add_custom_target(update-pot DEPENDS ${_potFile})

# Generate translations

file(GLOB _poFiles *.po)

set(_gmoFiles)
get_filename_component(_potName ${_potFile} NAME)
string(REGEX REPLACE "^(.+)(\\.[^.]+)$" "\\1" _potBasename ${_potName})
get_filename_component(_absPotFile ${_potFile} ABSOLUTE)

foreach (_currentPoFile ${_poFiles})
    get_filename_component(_absFile ${_currentPoFile} ABSOLUTE)
    get_filename_component(_abs_PATH ${_absFile} PATH)
    get_filename_component(_lang ${_absFile} NAME_WE)
    set(_gmoFile ${CMAKE_CURRENT_BINARY_DIR}/${_lang}.gmo)

    add_custom_command(
        OUTPUT ${_gmoFile}
        COMMAND ${GETTEXT_MSGMERGE_EXECUTABLE} --quiet --no-wrap --update --backup=none -s ${_absFile} ${_absPotFile}
        COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}  --check-format -o ${_gmoFile} ${_absFile}
        DEPENDS ${_absPotFile} ${_absFile}
    )

    install(FILES ${_gmoFile} DESTINATION ${COLOBOT_INSTALL_I18N_DIR}/${_lang}/LC_MESSAGES RENAME ${_potBasename}.mo)
    set(_gmoFiles ${_gmoFiles} ${_gmoFile})
endforeach()

add_custom_target(translations ALL DEPENDS ${_gmoFiles})

=== src/CMakeLists.txt ===
# Compile flags as defined in global CMakeLists
set(CMAKE_CXX_FLAGS "${COLOBOT_CXX_FLAGS} ${MXE_CFLAGS}")
set(CMAKE_CXX_FLAGS_RELEASE ${COLOBOT_CXX_FLAGS_RELEASE})
set(CMAKE_CXX_FLAGS_DEBUG ${COLOBOT_CXX_FLAGS_DEBUG})

# Groups source files for IDE project
macro(group_sources SOURCES GROUP_ROOT)
    foreach(SOURCE_FILE ${SOURCES})
        get_filename_component(GROUP "${SOURCE_FILE}" PATH)
        string(REPLACE "/" "\\" GROUP "${GROUP}")
        set(GROUP "${GROUP_ROOT}\\${GROUP}")
        source_group("${GROUP}" FILES "${SOURCE_FILE}")
    endforeach()
endmacro()

# Subdirectories

add_subdirectory(CBot)

if(TOOLS)
    add_subdirectory(tools)
endif()

add_subdirectory(graphics/opengl/shaders)


# Optional libraries
set(OPTIONAL_LIBS "")
set(OPTIONAL_INCLUDES "")

if(OPENAL_SOUND)
    set(OPTIONAL_LIBS ${OPENAL_LIBRARY})
    set(OPTIONAL_INCLUDES ${OPENAL_INCLUDE_DIR})
endif()

if(WINGETOPT)
    set(OPTIONAL_LIBS ${OPTIONAL_LIBS} wingetopt)
    set(OPTIONAL_INCLUDES ${OPTIONAL_INCLUDES} ${WINGETOPT_INCLUDE_DIR})
endif()

# Additional libraries per platform
if(MXE) # MXE requires special treatment
    set(PLATFORM_LIBS ${MXE_LIBS})
elseif(PLATFORM_WINDOWS)
    # because it isn't included in standard linking libraries
    if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
        find_library(LIBINTL_LIBRARY NAMES intl.lib libintl)

        if(${MSVC_STATIC})
            if (${OPENAL_SOUND})
                find_library(FLAC_LIBRARY NAMES flac.lib)
                find_library(VORBIS_LIBRARY NAMES vorbis.lib)
                find_library(VORBISENC_LIBRARY NAMES vorbisenc.lib)
                find_library(OGG_LIBRARY NAMES ogg.lib)
                set(OPENAL_MSVC_LIBS
                    ${FLAC_LIBRARY}
                    ${VORBIS_LIBRARY}
                    ${VORBISENC_LIBRARY}
                    ${OGG_LIBRARY}
                )
            endif()

            find_library(BZ2_LIBRARY NAMES bz2.lib)
            find_library(JPEG_LIBRARY NAMES jpeg.lib)
            find_library(TIFF_LIBRARY NAMES tiff.lib)
            find_library(WEBP_LIBRARY NAMES webp.lib)
            find_library(LZMA_LIBRARY NAMES lzma.lib)
            find_library(FREETYPE_LIBRARY NAMES freetype.lib)
            set(MSVC_LIBS
                ${LIBINTL_LIBRARY}
                ${OPENAL_MSVC_LIBS}
                ${JPEG_LIBRARY}
                ${TIFF_LIBRARY}
                ${BZ2_LIBRARY}
                ${WEBP_LIBRARY}
                ${LZMA_LIBRARY}
                ${FREETYPE_LIBRARY}
                winmm.lib
                dxguid.lib
                imm32.lib
                ole32.lib
                oleaut32.lib
                version.lib
                wsock32.lib
                ws2_32.lib
            )
        else(${MSVC_STATIC})
            set(MSVC_LIBS ${LIBINTL_LIBRARY})
        endif()

        set(PLATFORM_LIBS ${MSVC_LIBS})
    else()
        set(PLATFORM_LIBS "-lintl")
    endif()
elseif(PLATFORM_GNU)
    set(PLATFORM_LIBS "")
elseif(PLATFORM_LINUX)
    # for clock_gettime
    set(PLATFORM_LIBS "-lrt")
elseif(PLATFORM_MACOSX)
    find_library(LIBINTL_LIBRARY NAMES intl libintl)
    find_path(LIBINTL_INCLUDE_PATH NAMES libintl.h)
    set(PLATFORM_LIBS ${LIBINTL_LIBRARY})
endif()


# Configure file
configure_file(common/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/common/config.h)
configure_file(common/version.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/common/version.h)

set(OPENAL_SRC "")

if(OPENAL_SOUND)
    set(OPENAL_SRC
        sound/oalsound/alsound.cpp
        sound/oalsound/buffer.cpp
        sound/oalsound/channel.cpp
        sound/oalsound/check.cpp
        sound/oalsound/alsound.h
        sound/oalsound/buffer.h
        sound/oalsound/channel.h
        sound/oalsound/check.h
    )
endif()

set(RES_FILES "")

if(PLATFORM_WINDOWS)
    set(RES_FILES "../desktop/colobot.rc")
endif()

# Source files
set(BASE_SOURCES
    ${OPENAL_SRC}
    app/app.cpp
    app/app.h
    app/controller.cpp
    app/controller.h
    app/input.cpp
    app/input.h
    app/pathman.cpp
    app/pathman.h
    app/pausemanager.cpp
    app/pausemanager.h
    app/signal_handlers.cpp
    app/signal_handlers.h
    common/config_file.cpp
    common/config_file.h
    common/error.h
    common/event.cpp
    common/event.h
    common/font_loader.h
    common/font_loader.cpp
    common/global.h
    common/image.cpp
    common/image.h
    common/ioutils.h
    common/key.cpp
    common/key.h
    common/language.cpp
    common/language.h
    common/logger.cpp
    common/logger.h
    common/make_unique.h
    common/profiler.cpp
    common/profiler.h
    common/regex_utils.cpp
    common/regex_utils.h
    common/resources/inputstream.cpp
    common/resources/inputstream.h
    common/resources/inputstreambuffer.cpp
    common/resources/inputstreambuffer.h
    common/resources/outputstream.cpp
    common/resources/outputstream.h
    common/resources/outputstreambuffer.cpp
    common/resources/outputstreambuffer.h
    common/resources/resourcemanager.cpp
    common/resources/resourcemanager.h
    common/resources/sdl_file_wrapper.cpp
    common/resources/sdl_file_wrapper.h
    common/resources/sdl_memory_wrapper.cpp
    common/resources/sdl_memory_wrapper.h
    common/resources/sndfile_wrapper.cpp
    common/resources/sndfile_wrapper.h
    common/restext.cpp
    common/restext.h
    common/system/system.cpp
    common/system/system.h
    common/system/system_other.cpp
    common/system/system_other.h
    common/system/${SYSTEM_CPP_MODULE}
    common/system/${SYSTEM_H_MODULE}
    common/settings.cpp
    common/settings.h
    common/singleton.h
    common/stringutils.cpp
    common/stringutils.h
    common/thread/resource_owning_thread.h
    common/thread/sdl_cond_wrapper.h
    common/thread/sdl_mutex_wrapper.h
    common/thread/thread.h
    common/thread/worker_thread.h
    graphics/core/color.cpp
    graphics/core/color.h
    graphics/core/device.h
    graphics/core/framebuffer.cpp
    graphics/core/framebuffer.h
    graphics/core/light.h
    graphics/core/material.h
    graphics/core/nulldevice.cpp
    graphics/core/nulldevice.h
    graphics/core/texture.h
    graphics/core/type.cpp
    graphics/core/type.h
    graphics/core/vertex.h
    graphics/engine/camera.cpp
    graphics/engine/camera.h
    graphics/engine/cloud.cpp
    graphics/engine/cloud.h
    graphics/engine/engine.cpp
    graphics/engine/engine.h
    graphics/engine/lightman.cpp
    graphics/engine/lightman.h
    graphics/engine/lightning.cpp
    graphics/engine/lightning.h
    graphics/engine/oldmodelmanager.cpp
    graphics/engine/oldmodelmanager.h
    graphics/engine/particle.cpp
    graphics/engine/particle.h
    graphics/engine/planet.cpp
    graphics/engine/planet.h
    graphics/engine/pyro.cpp
    graphics/engine/pyro.h
    graphics/engine/pyro_manager.cpp
    graphics/engine/pyro_manager.h
    graphics/engine/pyro_type.h
    graphics/engine/terrain.cpp
    graphics/engine/terrain.h
    graphics/engine/text.cpp
    graphics/engine/text.h
    graphics/engine/water.cpp
    graphics/engine/water.h
    graphics/model/model.cpp
    graphics/model/model.h
    graphics/model/model_crash_sphere.h
    graphics/model/model_format.h
    graphics/model/model_input.cpp
    graphics/model/model_input.h
    graphics/model/model_io_exception.h
    graphics/model/model_io_structs.h
    graphics/model/model_manager.cpp
    graphics/model/model_manager.h
    graphics/model/model_mesh.cpp
    graphics/model/model_mesh.h
    graphics/model/model_output.cpp
    graphics/model/model_output.h
    graphics/model/model_shadow_spot.h
    graphics/model/model_triangle.h
    graphics/opengl/gl14device.cpp
    graphics/opengl/gl14device.h
    graphics/opengl/gl21device.cpp
    graphics/opengl/gl21device.h
    graphics/opengl/gl33device.cpp
    graphics/opengl/gl33device.h
    graphics/opengl/glframebuffer.cpp
    graphics/opengl/glframebuffer.h
    graphics/opengl/glutil.cpp
    graphics/opengl/glutil.h
    level/build_type.h
    level/level_category.cpp
    level/level_category.h
    level/mainmovie.cpp
    level/mainmovie.h
    level/parser/parser.cpp
    level/parser/parser.h
    level/parser/parserexceptions.cpp
    level/parser/parserexceptions.h
    level/parser/parserline.cpp
    level/parser/parserline.h
    level/parser/parserparam.cpp
    level/parser/parserparam.h
    level/player_profile.cpp
    level/player_profile.h
    level/research_type.h
    level/robotmain.cpp
    level/robotmain.h
    level/scene_conditions.cpp
    level/scene_conditions.h
    level/scoreboard.cpp
    level/scoreboard.h
    math/all.h
    math/const.h
    math/func.h
    math/geometry.h
    math/half.cpp
    math/half.h
    math/intpoint.h
    math/matrix.h
    math/point.h
    math/sphere.h
    math/vector.h
    object/auto/auto.cpp
    object/auto/auto.h
    object/auto/autobase.cpp
    object/auto/autobase.h
    object/auto/autoconvert.cpp
    object/auto/autoconvert.h
    object/auto/autoderrick.cpp
    object/auto/autoderrick.h
    object/auto/autodestroyer.cpp
    object/auto/autodestroyer.h
    object/auto/autoegg.cpp
    object/auto/autoegg.h
    object/auto/autofactory.cpp
    object/auto/autofactory.h
    object/auto/autoflag.cpp
    object/auto/autoflag.h
    object/auto/autohouston.cpp
    object/auto/autohouston.h
    object/auto/autojostle.cpp
    object/auto/autojostle.h
    object/auto/autokid.cpp
    object/auto/autokid.h
    object/auto/autolabo.cpp
    object/auto/autolabo.h
    object/auto/automush.cpp
    object/auto/automush.h
    object/auto/autonest.cpp
    object/auto/autonest.h
    object/auto/autonuclearplant.cpp
    object/auto/autonuclearplant.h
    object/auto/autoportico.cpp
    object/auto/autoportico.h
    object/auto/autopowercaptor.cpp
    object/auto/autopowercaptor.h
    object/auto/autopowerplant.cpp
    object/auto/autopowerplant.h
    object/auto/autopowerstation.cpp
    object/auto/autopowerstation.h
    object/auto/autoradar.cpp
    object/auto/autoradar.h
    object/auto/autorepair.cpp
    object/auto/autorepair.h
    object/auto/autoresearch.cpp
    object/auto/autoresearch.h
    object/auto/autoroot.cpp
    object/auto/autoroot.h
    object/auto/autotower.cpp
    object/auto/autotower.h
    object/auto/autovault.cpp
    object/auto/autovault.h
    object/crash_sphere.h
    object/drive_type.cpp
    object/drive_type.h
    object/implementation/power_container_impl.cpp
    object/implementation/power_container_impl.h
    object/implementation/program_storage_impl.cpp
    object/implementation/program_storage_impl.h
    object/implementation/programmable_impl.cpp
    object/implementation/programmable_impl.h
    object/implementation/task_executor_impl.cpp
    object/implementation/task_executor_impl.h
    object/interface/carrier_object.h
    object/interface/controllable_object.h
    object/interface/damageable_object.h
    object/interface/destroyable_object.h
    object/interface/flying_object.h
    object/interface/fragile_object.h
    object/interface/interactive_object.h
    object/interface/jet_flying_object.h
    object/interface/jostleable_object.h
    object/interface/movable_object.h
    object/interface/power_container_object.h
    object/interface/powered_object.h
    object/interface/program_storage_object.h
    object/interface/programmable_object.h
    object/interface/ranged_object.h
    object/interface/shielded_auto_regen_object.h
    object/interface/shielded_object.h
    object/interface/task_executor_object.h
    object/interface/trace_drawing_object.cpp
    object/interface/trace_drawing_object.h
    object/interface/transportable_object.h
    object/mission_type.h
    object/motion/motion.cpp
    object/motion/motion.h
    object/motion/motionant.cpp
    object/motion/motionant.h
    object/motion/motionbee.cpp
    object/motion/motionbee.h
    object/motion/motionhuman.cpp
    object/motion/motionhuman.h
    object/motion/motionlevelcontroller.cpp
    object/motion/motionlevelcontroller.h
    object/motion/motionqueen.cpp

=== src/CBot/CMakeLists.txt ===
set(SOURCES
    CBot.h
    CBotCStack.cpp
    CBotCStack.h
    CBotClass.cpp
    CBotClass.h
    CBotDebug.cpp
    CBotDebug.h
    CBotDefParam.cpp
    CBotDefParam.h
    CBotDefines.h
    CBotEnums.h
    CBotExternalCall.cpp
    CBotExternalCall.h
    CBotFileUtils.cpp
    CBotFileUtils.h
    CBotInstr/CBotBlock.cpp
    CBotInstr/CBotBlock.h
    CBotInstr/CBotBoolExpr.cpp
    CBotInstr/CBotBoolExpr.h
    CBotInstr/CBotBreak.cpp
    CBotInstr/CBotBreak.h
    CBotInstr/CBotCase.cpp
    CBotInstr/CBotCase.h
    CBotInstr/CBotCatch.cpp
    CBotInstr/CBotCatch.h
    CBotInstr/CBotCondition.cpp
    CBotInstr/CBotCondition.h
    CBotInstr/CBotDefArray.cpp
    CBotInstr/CBotDefArray.h
    CBotInstr/CBotDefBoolean.cpp
    CBotInstr/CBotDefBoolean.h
    CBotInstr/CBotDefClass.cpp
    CBotInstr/CBotDefClass.h
    CBotInstr/CBotDefFloat.cpp
    CBotInstr/CBotDefFloat.h
    CBotInstr/CBotDefInt.cpp
    CBotInstr/CBotDefInt.h
    CBotInstr/CBotDefString.cpp
    CBotInstr/CBotDefString.h
    CBotInstr/CBotDo.cpp
    CBotInstr/CBotDo.h
    CBotInstr/CBotEmpty.cpp
    CBotInstr/CBotEmpty.h
    CBotInstr/CBotExprLitBool.cpp
    CBotInstr/CBotExprLitBool.h
    CBotInstr/CBotExprLitNan.cpp
    CBotInstr/CBotExprLitNan.h
    CBotInstr/CBotExprLitNull.cpp
    CBotInstr/CBotExprLitNull.h
    CBotInstr/CBotExprLitNum.cpp
    CBotInstr/CBotExprLitNum.h
    CBotInstr/CBotExprLitString.cpp
    CBotInstr/CBotExprLitString.h
    CBotInstr/CBotExprRetVar.cpp
    CBotInstr/CBotExprRetVar.h
    CBotInstr/CBotExprUnaire.cpp
    CBotInstr/CBotExprUnaire.h
    CBotInstr/CBotExprVar.cpp
    CBotInstr/CBotExprVar.h
    CBotInstr/CBotExpression.cpp
    CBotInstr/CBotExpression.h
    CBotInstr/CBotFieldExpr.cpp
    CBotInstr/CBotFieldExpr.h
    CBotInstr/CBotFor.cpp
    CBotInstr/CBotFor.h
    CBotInstr/CBotFunction.cpp
    CBotInstr/CBotFunction.h
    CBotInstr/CBotIf.cpp
    CBotInstr/CBotIf.h
    CBotInstr/CBotIndexExpr.cpp
    CBotInstr/CBotIndexExpr.h
    CBotInstr/CBotInstr.cpp
    CBotInstr/CBotInstr.h
    CBotInstr/CBotInstrCall.cpp
    CBotInstr/CBotInstrCall.h
    CBotInstr/CBotInstrMethode.cpp
    CBotInstr/CBotInstrMethode.h
    CBotInstr/CBotInstrUtils.cpp
    CBotInstr/CBotInstrUtils.h
    CBotInstr/CBotLeftExpr.cpp
    CBotInstr/CBotLeftExpr.h
    CBotInstr/CBotLeftExprVar.cpp
    CBotInstr/CBotLeftExprVar.h
    CBotInstr/CBotListArray.cpp
    CBotInstr/CBotListArray.h
    CBotInstr/CBotListExpression.cpp
    CBotInstr/CBotListExpression.h
    CBotInstr/CBotListInstr.cpp
    CBotInstr/CBotListInstr.h
    CBotInstr/CBotLogicExpr.cpp
    CBotInstr/CBotLogicExpr.h
    CBotInstr/CBotNew.cpp
    CBotInstr/CBotNew.h
    CBotInstr/CBotParExpr.cpp
    CBotInstr/CBotParExpr.h
    CBotInstr/CBotPostIncExpr.cpp
    CBotInstr/CBotPostIncExpr.h
    CBotInstr/CBotPreIncExpr.cpp
    CBotInstr/CBotPreIncExpr.h
    CBotInstr/CBotReturn.cpp
    CBotInstr/CBotReturn.h
    CBotInstr/CBotSwitch.cpp
    CBotInstr/CBotSwitch.h
    CBotInstr/CBotThrow.cpp
    CBotInstr/CBotThrow.h
    CBotInstr/CBotTry.cpp
    CBotInstr/CBotTry.h
    CBotInstr/CBotTwoOpExpr.cpp
    CBotInstr/CBotTwoOpExpr.h
    CBotInstr/CBotWhile.cpp
    CBotInstr/CBotWhile.h
    CBotProgram.cpp
    CBotProgram.h
    CBotStack.cpp
    CBotStack.h
    CBotToken.cpp
    CBotToken.h
    CBotTypResult.cpp
    CBotTypResult.h
    CBotUtils.cpp
    CBotUtils.h
    CBotVar/CBotVar.cpp
    CBotVar/CBotVar.h
    CBotVar/CBotVarValue.h
    CBotVar/CBotVarArray.cpp
    CBotVar/CBotVarArray.h
    CBotVar/CBotVarBoolean.cpp
    CBotVar/CBotVarBoolean.h
    CBotVar/CBotVarClass.cpp
    CBotVar/CBotVarClass.h
    CBotVar/CBotVarFloat.cpp
    CBotVar/CBotVarFloat.h
    CBotVar/CBotVarInt.cpp
    CBotVar/CBotVarInt.h
    CBotVar/CBotVarPointer.cpp
    CBotVar/CBotVarPointer.h
    CBotVar/CBotVarString.cpp
    CBotVar/CBotVarString.h
    stdlib/Compilation.cpp
    stdlib/Compilation.h
    stdlib/FileFunctions.cpp
    stdlib/MathFunctions.cpp
    stdlib/StringFunctions.cpp
    stdlib/stdlib.h
    stdlib/stdlib_public.h
)

# Includes
set(LOCAL_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}/..
)

set(SYSTEM_INCLUDES
    ${Boost_INCLUDE_DIRS}
)

include_directories(${LOCAL_INCLUDES})
include_directories(SYSTEM ${SYSTEM_INCLUDES})


if(CBOT_STATIC)
    add_library(CBot STATIC ${SOURCES})
else()
    add_library(CBot SHARED ${SOURCES})
    install(TARGETS CBot LIBRARY
            DESTINATION ${COLOBOT_INSTALL_LIB_DIR}
            ARCHIVE DESTINATION ${COLOBOT_INSTALL_LIB_DIR}
            RUNTIME DESTINATION ${COLOBOT_INSTALL_BIN_DIR})
endif()

group_sources("${SOURCES}" "Source Files")

=== debian/changelog ===
colobot (0.1.12-7) unstable; urgency=medium

  [ Anton Gladky ]
  * Fix FTBFS against boost_1.74 (Closes: #974603)

 -- Didier Raboud <odyx@debian.org>  Fri, 13 Nov 2020 17:04:55 +0100

colobot (0.1.12-6) unstable; urgency=medium

  * d/rules cleanup:
    - Add clarifying comments
    - Drop obsolete dh_strip ddeb-migration
    - Pass -DCMAKE_SKIP_INSTALL_ALL_DEPENDENCY=OFF to keep building arch:all
      only under debhelper 13

 -- Didier Raboud <odyx@debian.org>  Fri, 24 Jul 2020 15:55:27 +0200

colobot (0.1.12-5) unstable; urgency=medium

  * Backport upstream 'fix missing std includes' patch, fixing FTBFS with
    GCC-10 (Closes: #957096)
  * Lintian-brush:
    - Bump debhelper from old 10 to 13.
    - Set debhelper-compat version in Build-Depends.
    - Set upstream metadata fields: Bug-Database, Bug-Submit.
    - Rely on pre-initialized dpkg-architecture variables.
  * Install missing icons and metainfo; list the non-installed files

 -- Didier Raboud <odyx@debian.org>  Fri, 24 Jul 2020 09:25:02 +0200

colobot (0.1.12-4) unstable; urgency=medium

  * Add patch to use data translations from current 'dev', to get the most
    recent french translations
  * Bump S-V to 4.5.0 without changes needed

 -- Didier Raboud <odyx@debian.org>  Fri, 01 May 2020 15:10:00 +0200

colobot (0.1.12-3) unstable; urgency=medium

  * Add patch from Simon McVittie on opnjk to rely on libsdl2-dev (>= 2.0.4)
    providing a CMake "config-file package"; fixes FTBFS (Closes: #952012)

 -- Didier Raboud <odyx@debian.org>  Tue, 25 Feb 2020 10:15:18 +0100

colobot (0.1.12-2) unstable; urgency=medium

  [ Didier Raboud ]
  * Upload to unstable
    - Fixes FTBFS on GCC-9 (Closes: #925656)

  [ Reiner Herrmann ]
  * Add watch file

 -- Didier Raboud <odyx@debian.org>  Sat, 17 Aug 2019 16:51:34 +0200

colobot (0.1.12-1) experimental; urgency=low

  * New 0.1.12 upstream release

  * Refresh patches
  * Update dh_auto_configure call for OFFICIAL_COLOBOT_BUILD variable rename
  * Revert 'Fix Linux savegame path issue' upstream change: don't move from
    XDG_CONFIG_DATA to XDG_DATA_HOME just now; it needs proper migration

 -- Didier Raboud <odyx@debian.org>  Sun, 24 Feb 2019 13:18:07 +0100

=== debian/control ===
Source: colobot
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Didier Raboud <odyx@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 google-mock,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-regex-dev,
 libboost-system-dev,
 libgl1-mesa-dev | libgl-dev,
 libglew-dev,
 libgtest-dev,
 libopenal-dev,
 libpng-dev,
 libphysfs-dev,
 librsvg2-bin,
 libsdl2-image-dev,
 libsdl2-ttf-dev,
 libsdl2-dev (>= 2.0.4~),
 libsndfile-dev,
 perl,
 po4a,
 xmlstarlet,
Build-Depends-Indep:
 doxygen,
 graphviz,
 vorbis-tools,
Vcs-Browser: https://salsa.debian.org/games-team/colobot
Vcs-Git: https://salsa.debian.org/games-team/colobot.git
Standards-Version: 4.5.0
Homepage: https://colobot.info

Package: colobot
Architecture: any
Depends:
 colobot-common (>= ${source:Version}),
 colobot-common-sounds (>= ${source:Version}),
 colobot-common-textures (>= ${source:Version}),
 fonts-dejavu-core,
 fonts-dejavu-extra,
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 colobot-common (<< 0.1.1-2)
Breaks:
 colobot-common (<< 0.1.1-2)
Description: educational programming strategy game
 Colobot (Colonize with Bots) is an educational game aiming to teach
 programming through entertainment. You are playing as an astronaut on a
 journey with robot helpers to find a planet for colonization. It features 3D
 real-time graphics and a C++ and Java-like, object-oriented language, CBOT,
 which can be used to program the robots available in the game.

Package: colobot-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Recommends:
 colobot (>= ${source:Version})
Description: educational programming strategy game - data
 Colobot (Colonize with Bots) is an educational game aiming to teach
 programming through entertainment. You are playing as an astronaut on a
 journey with robot helpers to find a planet for colonization. It features 3D
 real-time graphics and a C++ and Java-like, object-oriented language, CBOT,
 which can be used to program the robots available in the game.
 .
 This package contains the architecture-independent game data.

Package: colobot-common-textures
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Recommends:
 colobot (>= ${source:Version})
Replaces:
 colobot-common (<< 0.1.1-2)
Breaks:
 colobot-common (<< 0.1.1-2)
Description: educational programming strategy game - textures
 Colobot (Colonize with Bots) is an educational game aiming to teach
 programming through entertainment. You are playing as an astronaut on a
 journey with robot helpers to find a planet for colonization. It features 3D
 real-time graphics and a C++ and Java-like, object-oriented language, CBOT,
 which can be used to program the robots available in the game.
 .
 This package contains the textures for the game.

Package: colobot-common-sounds
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Recommends:
 colobot (>= ${source:Version})
Replaces:
 colobot-common (<< 0.1.1-2)
Breaks:
 colobot-common (<< 0.1.1-2)
Description: educational programming strategy game - sounds and music
 Colobot (Colonize with Bots) is an educational game aiming to teach
 programming through entertainment. You are playing as an astronaut on a
 journey with robot helpers to find a planet for colonization. It features 3D
 real-time graphics and a C++ and Java-like, object-oriented language, CBOT,
 which can be used to program the robots available in the game.
 .
 This package contains the sounds and music for the game.

Package: colobot-dev-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 libjs-jquery,
 ${misc:Depends}
Recommends:
 colobot (>= ${source:Version})
Description: educational programming strategy game - source doc
 Colobot (Colonize with Bots) is an educational game aiming to teach
 programming through entertainment. You are playing as an astronaut on a
 journey with robot helpers to find a planet for colonization. It features 3D
 real-time graphics and a C++ and Java-like, object-oriented language, CBOT,
 which can be used to program the robots available in the game.
 .
 This package contains the doxygen documentation for the colobot source code.

=== debian/rules ===
#!/usr/bin/make -f

# Hippomocks doesn't support some Debian architectures
HIPPOMOCKS_BROKEN_ARCHS=armel armhf arm64 mips mips64el mipsel

include /usr/share/dpkg/architecture.mk

CBOT_CONFIGURE=-DMUSIC:BOOL=False
# Only encode the music files if needed
ifneq (,$(findstring colobot-common-sounds, $(shell dh_listpackages)))
CBOT_CONFIGURE=-DMUSIC:BOOL=True -DMUSIC_FLAC:BOOL=True
endif

ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(HIPPOMOCKS_BROKEN_ARCHS)))
CBOT_CONFIGURE+=-DTESTS:BOOL=False
else
CBOT_CONFIGURE+=-DTESTS:BOOL=True
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE:STRING="RelWithDebInfo" \
	                     -DCMAKE_SKIP_INSTALL_ALL_DEPENDENCY=OFF \
	                     -DOFFICIAL_COLOBOT_BUILD:BOOL=True \
	                     -DINSTALL_DOCS:BOOL=True \
	                     ${CBOT_CONFIGURE} \
	                     -DPYTHON_EXECUTABLE=/usr/bin/python3 \
	                     -DOPENAL_SOUND:BOOL=True \
	                     -DCMAKE_VERBOSE_MAKEFILE=True

override_dh_auto_build-arch:
	dh_auto_build -a

override_dh_auto_build-indep:
	dh_auto_build -i -- doc

ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(HIPPOMOCKS_BROKEN_ARCHS)))
override_dh_auto_test-arch:
	# Allow the tests to fail on that architecture, see #843690
	- dh_auto_test -a
endif

# Skip tests in arch:all build
override_dh_auto_test-indep:
